﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace LabelTest {
	public class CustomControl : Control {
		static CustomControl() {
			DefaultStyleKeyProperty.OverrideMetadata(typeof(CustomControl), new FrameworkPropertyMetadata(typeof(CustomControl)));
		}


		public List<string> Lines {
			get { return (List<string>)GetValue(LinesProperty); }
			set { SetValue(LinesProperty, value); }
		}

		public string Text {
			get { return (string)GetValue(TextProperty); }
			set { SetValue(TextProperty, value); }
		}

		public static readonly DependencyProperty TextProperty =
			DependencyProperty.Register("Text", typeof(string), typeof(CustomControl), new PropertyMetadata(null, OnTextChanged));
		
		public static readonly DependencyProperty LinesProperty =
			DependencyProperty.Register("Lines", typeof(List<string>), typeof(CustomControl), new PropertyMetadata(null));



		private static void OnTextChanged(DependencyObject d, DependencyPropertyChangedEventArgs e) {
			(d as CustomControl).OnTextChanged(e.OldValue as string, e.NewValue as string);
		}

		private void OnTextChanged(string oldValue,string newValue) {
			Lines = newValue.Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries).ToList();
		}
	}
}
